/*
  Name: GPS Compass
  Copyright: 
  Author: Georgi N. Chakarov
  Date: 21.07.08 13:22
  Description: Inputs an angle in degrees and creates a compass
               in an array and displays it. 
*/

#include <iostream>
#include <math.h>
using namespace std;
#include "trigonometry.h"


#define CENTERX 17
#define CENTERY 17
#define r       16
#define PI      3.1415926535897932384626433832795



int n;
int a[100][100];
//volatile int alpha=0;  //the arrow angle relative to North

double dist(int x1, int y1, double x2, double y2)
{return sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));}

void draw_circle()
{
   double d1, d2;
   char ch;
   int i, j;
   for(i=CENTERX-r; i<=CENTERX; i++)
	   for(j=CENTERY; j<=CENTERY+r; j++)
  		{
		 	d1=dist(CENTERX, CENTERY, i-0.39, j+0.39);
	        d2=dist(CENTERX, CENTERY, i+0.39, j-0.39); 
			if(d2<r && r<d1)
			{
 		      a[i][j]=1;
              a[2*CENTERX-i][j]=1;
 		      a[i][2*CENTERY-j]=1;
			  a[j][i]=1;
	        }
	    }  	 
}

void print()
{ 
 	/*
 	   LCDInit();
 	   LCDPixel();
    */
	 
	  int i, j;
     cout << "  " << endl;
     for (i=0; i<n; i++)
 	 {
	  	 for(j=0; j<n; j++)
	  	 {
  		    if(a[i][j]==0) cout << "  ";
  		    else cout << "* ";
         }
         cout << endl;
     }
     cout << endl << endl;
}

void clear()
{
    int i, j;	
    for(i=0; i<n; i++)
 	   for(j=0; j<n; j++)
 	      a[i][j]=0;
}

void draw_compass(int alpha, int num)
{
   n=num;
   int x1, x2, y1, y2;
   int y1s, x1s, x1t;
   int swap;
   char ch;
   int incx, incy;
   double cotga;   //cotangens alpha

	 x1=CENTERX;
	 y1=CENTERY;
	 if(alpha==0 || alpha==360){x2=CENTERX-r; y2=CENTERY;}
	 if(alpha>0 && alpha<180)
	 {
	   x2=CENTERX-cosa(alpha)*r;
	   y2=CENTERY+sina(alpha)*r;
	 }
	 if(alpha==180){x2=CENTERX+r; y2=CENTERY;}
	 if(alpha==270){int h; for(h=CENTERY-r; h<=CENTERY; h++) a[CENTERX][h]=1;}
	 if(alpha>180 && alpha<360)
	 {
	   
	   x2=CENTERX+cosa((alpha-180))*r;
	   y2=CENTERY-sina((alpha-180))*r;
	 }
	 
	 x1s=x1; y1s=y1;
	 
	
	 if(y1>y2)
	 {
        swap=x1; x1=x2; x2=swap;
        swap=y1; y1=y2; y2=swap;
     }
	 
	 
	 incx=abs(x2-x1);
	 incy=abs(y2-y1);
	 cotga=(double)incx/incy;
	
	 if(x1 < x2)
	 while(x1 < x2+1 && y1< y2+1)
	 {
        if((double)(x1-x1s+1)==(double)(y1-y1s+1)*cotga)
	  	{
			a[x1][y1]=1;
			x1++; y1++;
			continue;
		}
	    if((double)(x1-x1s+1)/cotga > (y1-y1s+1))
	  	{
	      a[x1][y1]=1;
	      y1++;
          continue;
		}
		if((double)(y1-y1s+1)*cotga > (x1-x1s+1))
		{
           a[x1][y1]=1;
           x1++;
           continue;
        }
     }
     
     if(x1>x2)
     {
	  x1t=x1;
	  swap=x1; x1=x2; x2=swap;
	  x1s=x1; y1s=y1;
	  while(x1 < x2+1 && y1< y2+1)
	  {
        if((double)(x1-x1s+1)==(double)(y1-y1s+1)*cotga)
	  	{
			a[x1t][y1]=1;
			x1++; y1++; x1t--;
			continue;
		}
	    if((double)(x1-x1s+1)/cotga > (y1-y1s+1))
	  	{
	      a[x1t][y1]=1;
	      y1++;
          continue;
		}
		if((double)(y1-y1s+1)*cotga > (x1-x1s+1))
		{
           a[x1t][y1]=1;
           x1++;
           x1t--;
           continue;
        }
      }
	 }     
  	 draw_circle(); 		    
     print ();
     clear();
}
